/* Sistemas Integrados TECNISA

Nome: 00NH_CDPTRGS_DTULTATU_PERIPRODUCAO.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela PERIPRODUCAO

Criao:
07/05/2007 Ronald Reis
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PERIPRODUCAO' and
            type = 'TR'                    and
            u.uid = o.uid                  and
            u.name = USER)
  DROP TRIGGER DTULTATU_PERIPRODUCAO
  GO

CREATE TRIGGER DTULTATU_PERIPRODUCAO
ON PERIPRODUCAO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PERIPRODUCAO', '', 'CDPERIPRODU=' + CDPERIPRODU+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PERIPRODUCAO
      SET DTULTATUPERP = GETDATE()
      FROM INSERTED
      WHERE ISNULL(PERIPRODUCAO.CDPERIPRODU,0) = ISNULL(INSERTED.CDPERIPRODU,0);
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_PERIPRODUCAO','4.11.134';
GO
